%Ufxxx ; File i/o Library - Version 0.5.0.4
 ; A.Trocha [1999/02/01-20:20:05]
 ; Utility common file handling subroutines ; Jon Diamond ; 1999-02-18
 ; $Source: /usr/local/src/FreeM/mlib/RCS/%FUTIL.m,v $
 ;
 ; Modified by Jon Diamond for %U standards
 Q
 ; 
 ; 
direx(path) ;--- test if directory exists
 ;        0 = does not exist     1 = success
 ;
 i $zv["Cache" d
 . w "***Not yet implemented***"
 e  d 
 . S $ZT="%direx99^"_$ZN
 . N tmp
 . S tmp=$V(2)
 . V 2:path
 . V 2:tmp
 Q 1
 ; 
%direx99 ;--- error
 Q 0
 ; 
 ; 
mkdir(path) ;--- create directory
 ;        0 = error      1 = ok
 ; 
 i $zv["Cache" d
 . w "***Not yet implemented***"
 e  d
 . N exec
 . S exec="!mkdir "_path_">/dev/null"
 . X exec
 Q $$direx(path)
 ; 
 ; 
rmdir(path) ;--- delete directory   "rm -r"
 ; **** take care ****
 i $zv["Cache" d
 . w "***Not yet implemented***"
 e  d
 . N exec
 . S exec="!rm -r "_path_">/dev/null"
 . X exec
 Q '$$direx(path)
 ; 
 ; SELECT DEVICE
 ; 
select(device,type,params) 
 n error,d,ntype
 s d=$g(device),type=$g(type),params=$g(params) i type="" s type="in"
%select1 
 s device=d
 s error=$$readn^%Uxxxx($s(type="in":"Input",type="inout":"Input/Output",1:"Output")_" device: ",.device,"%Uf.device")
 i error<0 q error
 s ntype=type
 ; 
 ; **** add stuff for parameters etc.??????
 ; **** is it possible to validate for a device name???
 ; **** may want to output to pseudo-device, e.g. global/file
%select2 
 s error=$$open(device,ntype,params,0)
 i error'<0 s device=$p(error,",",1) q "0,select^%Ufxxx"
 i +error=-1 q error
 i +error'=-103 s a=$$merror^%Uxxxx(error) g %select1
 ; 
 ; Now try again if we didn't try and open the file as a new one
 i ntype'="in",ntype'="new" s ntype="new" g %select2
 s a=$$rerror^%Uxxxx("Device not available")
 g %select1
 ; 
 ; 
 ; OPEN DEVICE
 ; 
open(device,type,params,timeout) 
 n error s error=0
 ; ***** error trapping probably needed here to allow for
 ; ***** device selection
 ; ***** and parameters to be incorrect in some way
 s device=$g(device),params=$g(params)
 i device=""!(device=0)!(device=$i) q $i_",open^%Ufxxx"
 s timeout=$g(timeout)
 s type=$g(type,"in")
 ; 
 ; Next bit needs to distinguish between different ways of handling device as a file name
 ; and type
 ; Assumes non-standard $ZV for the time being
 ; 
 ; First Cache
 i $zv["Cache" d
 . s params=$s(type="out":"W",type="new":"WN",type="inout":"RW",1:"R")_params
 . s error=device
 . i timeout="" o device:params
 . e  o device:params:timeout e  s error=-103
 ; 
 ; Now assume FreeM device handling
 ; Uses device 4 temporarily - needs changing
 e  d
 . n file,newpath,oldpath,x
 . s params="/"_$s(type="out":"w",type="new":"w",type="inout":"rw",1:"r")_params
 . s error=4,oldpath=$V(9),x=$l(device,"/") i x=0 s x=1
 . s newpath=$p(device,"/",1,x-1),file=$p(device,"/",x)
 . V 9:newpath
 . i timeout="" o error:file_params
 . e  o error:file_params:timeout e  s error=-103
 . V 9:oldpath
 q error_",open^%Ufxxx"
 ; 
 ; 
 ; CLOSE DEVICE
close(device) 
 s device=$g(device)
 i device=""!(device=0)!(device=$i) q "0,close^%Ufxxx"
 ; ***** do we need to add parameters on close here???
 c device
 q "0,close^%Ufxxx"
 ; 
 ; READ 
 ; 
read(device,result,length,timeout) 
 n a,dev,error
 i '$d(%Uwork) s error=$$init^%Uxxxx
 s dev=$i,device=$g(device)
 i dev'=device,device'=0,device'="" u device
 ; 
 i $g(timeout)="" d
 . r a
 e  d
 . r a:$g(timeout)
 ; 
 u dev
 i a'="" s result=a
 i $g(length),$l(result)>length q "-101,read^%Ufxxx"
 ; 
 q "0,read^%Ufxxx"
 ; 
 ; 
 ; WRITE TEXT
write(device,text) 
 n dev,error
 i '$d(%Uwork) s error=$$init^%Uxxxx i error q error
 s dev=$i,device=$g(device)
 i dev'=device,device'=0,device'="" u device
 ; 
 w text,!
 u dev
 q "0,write^%Ufxxx"
 ; 
 ; Write header
header(device,type,comment) 
 n error
 s error=$$write^%Ufxxx(device,"**** "_type_" ~ "_$$^%Uxdat($h,1)_" ****") i error<0 q error
 s error=$$write^%Ufxxx(device,"**** "_$g(comment)_" ****") i error<0 q error
 q "0,header^%Ufxxx"
 ; 
 ; Write trailer
trailer(device,type) 
 n a,error
 s a="**** "_$g(type)_" ~ "_$$^%Uxdat($h,1)_" ****"
 s error=$$write^%Ufxxx(device,"") i error<0 q error
 s error=$$write^%Ufxxx(device,a) i error q error
 q "0,trailer^%Ufxxx"
