%Urexp ; Routine export utility - Version 0.5.0.4
 ; Jon Diamond - 1999-03-31
 ; 
 n comment,device,error,sep,version
 s error=$$init^%Uxxxx(),comment="",version="",device="",sep=0
 ; 
 s error=$$writen^%Uxxxx($t(+1)_"  "_$$^%Uxdat)
 k @%Uwork
%rsel s error=$$rsel^%Urxxx(%Uwork) q:error<0
 i $o(@%Uwork@(99999))="" s error=$$writep^%Uxxxx("No Routines selected") q
 ; 
%sep s error=$$readyn^%Uxxxx("Create separate file for each routine?",.sep,"%Urexp.separate")
 i error<0 g %rsel
%device i 'sep g %dev1
 s device="",error=$$readn^%Uxxxx("Path ",.device,"%U.path")
 i error<0 g %sep
 g %comment
 ; 
%dev1 i device'="" s error=$$close^%Ufxxx(device) i error<0 g %exit1
 s error=$$select^%Ufxxx(.device,"out") 
 i error<0 g %sep
 ; 
%comment i sep g %version 
 s error=$$readn^%Uxxxx("Header comment ",.comment,"%Urexp.comment")
 i error<0 g %device
 ; 
%version s error=$$readn^%Uxxxx("Add version text ",.version,"%Urexp.version")
 i error<0 g %comment
 ; 
 s error=$$go(device,%Uwork,comment,version,sep) i error<0 s a=$$error^%Uxxxx(error) g %exit
 s error=$$writep^%Uxxxx("Routines written - "_+error)
 s error=$$writep^%Uxxxx("Finished")
 ; 
%exit s error=$$close^%Ufxxx(device) i error<0 ; ??? if error
%exit1 k @%Uwork
 q
 ; 
 ; Executable entry point
 ; Needs modifying to allow a selection mask (major changes!)
go(device,select,comment,version,sep)
 n cnt,error,path
 s version=$g(version),sep=$g(sep),path=device i path'="" s path=path_"/"
 i version'="",version'?." "1P.e s version=" ; "_version
 i 'sep s error=$$header^%Ufxxx(device,$t(+1),$g(comment)) i error<0 q error
 ; 
 s (cnt,error)=$$process^%Urxxx(select,"d %goexp^%Urexp")
 ;
 ; At end of all write trailer
 i 'sep,error'<0 s error=$$trailer^%Ufxxx(device,$t(+1))
 i error<0 q error
 q +cnt_",go^%Urexp"
 ;         
%goexp ;
 ; Check whether routine has first line
 s b=$t(@("+1^"_a)) q:b=""
 ;
 ; Now open "new" file with a .m extension or add to end of existing file
 i sep d
 . s error=$$open^%Ufxxx(path_a_".m","new")
 . s device=$p(error,",",1)
 e  s error=$$write^%Ufxxx(device,a)
 q:error<0
 s error=$$write^%Ufxxx(device,b_version) q:error<0
 ;
 f c=2:1 s b=$t(@("+"_c_"^"_a)) q:b=""  s error=$$write^%Ufxxx(device,b) q:error<0
 q:error<0
 ; 
 ; Now write trailer or close file
 s cnt=cnt+1
 i sep s error=$$close^%Ufxxx(device) q
 s error=$$write^%Ufxxx(device,"")
 q
 ; 
 ; 
 ; Alternative entry point with Open/Close included
export(device,select,comment,version) 
 n error,result
 s error=$$open^%Ufxxx(device,"out") q:error<0
 s device=$p(error,",",1)
 s error=$$go(device,$g(select),$g(comment),$g(version)) q:error<0
 s result=$p(error,",",1)
 s error=$$close^%Ufxxx(device)
 q result_",export^%Urexp"
