%Urimp ; Routine Import Utility - Version 0.5.0.4
 ; Jon Diamond - 1999-03-31
 ;
 n error,select,device,header,comment,yes,cnt,sel
 s error=$$init^%Uxxxx(),device=""
 ;
 w !,$t(+1),"  ",$$^%Uxdat()
 ;
 k @%Uwork
 ;
%device i device'="" s error=$$close^%Ufxxx(device) i err<0 g %exit1
 s error=$$select^%Ufxxx(.device,"in") 
 i error<0 g %exit1
 ;
 s error=$$%header i error<0 s a=$$writep^%Uxxxx("Header error on input file") g %exit
 s error=$$writep^%Uxxxx("Header - "_header) i error<0 g %exit
 s error=$$writep^%Uxxxx("Description - "_comment) i error<0 g %exit
 ;
%cont s yes=1
 s error=$$readyn^%Uxxxx("Continue? ",.yes,"%Urimp.continue")
 i error<0 g %device
 i 'yes g %exit
 ;
%all s all=1
 s error=$$readyn^%Uxxxx("Restore all routines? ",.all,"%Urimp.all") 
 i error<0 g %cont
 ;
%go s error=$$go(device,all) i error<0 s a=$$error^%Uxxxx(error) g %exit
 s cnt=+error
 s error=$$writep^%Uxxxx("Finished")
 s error=$$writep^%Uxxxx("Routines restored - "_cnt)
 ;
%exit i device'="" s error=$$close^%Ufxxx(device) i error<0 ; ??? if error
%exit1 k @%Uwork
 q
 ;
%header()
 s (header,comment)=""
 s error=$$read^%Ufxxx(device,.header) i error<0 q error
 s error=$$read^%Ufxxx(device,.comment) i error<0 q error
 q "0,%header^%Urimp"
 ;
 ; Executable entry point
 ; Needs modifying to allow a selection mask (major changes!)
go(device,all)
 n name,d,error,cnt,this,replace,line
 s cnt=0,all=$g(all,1)
%go1 s name=""
 s error=$$read^%Ufxxx(device,.name) i error<0 q error
 i name="" g %go1
 i '$$valid^%Urxxx(name) g %go2
 s replace=name,this=1
 i all s error=$$writep^%Uxxxx("Processing - "_name) g %go1b
%go1a s error=$$readn^%Uxxxx("Restore as ",.replace,"%Urimp.restore") i error<0 q error
 i this,replace="*" s all=1,replace=name
 i this,replace="-" s this=0
 i this,replace'?1a.30an,replace'?1"%".30an s error=$$rerror^%Uxxxx("Invalid routine name") g %go1a
%go1b k line 
 f d=1:1 s line="",error=$$read^%Ufxxx(device,.line) q:error<0!(line="")  s line(d)=line i d=1,$p(line," ")=name s $p(line(d)," ",1)=replace
 i this s error=$$save^%Urxxx(replace,.line) q:error<0 error  s cnt=cnt+1
 g %go1
 ;
%go2 i name?1"****".e1"****" q cnt_",go^%Urimp"
 s error=$$error^%Uxxxx("Invalid routine name - "_name) 
 g %go1
 ;
 ;
 ; Alternative entry point with Open/Close included
import(device,all)
 n error
 s error=$$open^%Ufxxx(device,"in") q:error<0
 s device=$p(error,",",1)
 s error=$$go(device,all) q:error<0
 s error=$$close^%Ufxxx(device)
 q
