%Uxxxx ; FreeM %U utility library - Version 0.5.0.4
 ; Jon Diamond - 1999-03-31
 q
 ; 
 ; INITIALISATION
init() n a
 i $d(^%Uparams) s a="^%Uparams"
 e  s a="^uparams"
 ; 
 s %Uwork=$g(@a@("work")) i %Uwork="" s %Uwork="^uwork("""_$j_""")"
 ; Really should be as below, but needs $system to be implemented
 ;s %Uwork=$g(@a@("work"),"^uwork("""_$system_""","""_$j_""")")
 ; 
 s %Uwork("lang")=$g(@a@("lang")) i %Uwork("lang")="" s %Uwork("lang")=0
 s %Uwork("prompt")=$g(@a@("prompt")) i %Uwork("prompt")="" s %Uwork("prompt")="^ulang"
 ; 
 s %Uwork("save")=$g(@a@("save")) i %Uwork("save")="" s %Uwork("save")="^usave"        
 ; 
 s %Uwork("help")=$g(@a@("help")) i %Uwork("help")="" s %Uwork("help")="^uhelp"
 q "0,init^%Uxxxx"
 ; 
 ; 
 ; READ WITH PROMPT
read(prompt,result,help,length,PX,PY,X,Y,timeout) 
 n a,error
 s prompt=$g(prompt)
%read1 i prompt'="" s error=$$write(prompt,$g(PX),$g(PY)) i error q error
 i $g(result)'="" s error=$$write(" <"_result_"> ") i error q error
 ; 
 ; move to X,Y ********
 i $g(X)'="" s $x=$g(X)
 i $g(Y)'="" s $y=$g(Y)
 i $g(timeout)="" d
 . r a
 e  d
 . r a:$g(timeout)
 ; 
 ; **** hitting escape or escape sequence processing???
 i a="^" q "-1,read^%Uxxxx" ; *** Standard abort
 i a="?" s error=$$help($g(help),prompt) w ! g %read1
 i a="@" s (a,result)=""
 i a="^^" s a="^"
 i a="^?" s a="?"
 i a="^@" s a="@"
 i a'="" s result=a
 i $g(length),$l(result)>length s error=$$error("Too many characters") g %read1
 ; 
 q "0,read^%Uxxxx"
 ; 
 ; 
 ; READ WITH NEWLINE FIRST
readn(prompt,result,help,length,timeout) 
 n a,error,PX,PY,X,Y
 s prompt=$$lprompt($g(prompt))
 w !
 g %read1
 ; 
 ; 
 ; READN FOR YES/NO
readyn(prompt,result,help) 
 n error,res,def
 s def=$g(result),def=$$lprompt($s(def=1:"Y",def=0:"N",1:""))
%readyn1 s res=def
 s error=$$readn(prompt,.res,$g(help)) i error<0 q error
 s res=$$upper(res)
 i res=$$lprompt("Y") s result=1
 e  i res=$$lprompt("N") s result=0
 e  s error=$$write(" - "_$$lprompt("Enter Y or N")) g %readyn1
 q "0,readyn^%Uxxxx"
 ; 
 ; Application Validation Error display after Read (of any kind)
rerror(err)  i err?1"?".e q $$write(" "_err)
 q $$write(" - "_$$lprompt(err))
 ; 
 ; Application  Error display after Read (of any kind)
 ; Should interpret error codes
merror(err)  
 q $$write(" - "_$$lprompt("Internal error - "_err))
 ; 
 ; WRITE TEXT
write(text,X,Y) 
 n error
 ; 
 ; move to X,Y ********
 i $g(X)'="" s $x=$g(X)
 i $g(Y)'="" s $y=$g(Y)
 w text
 q "0,write^%Uxxxx"
 ; 
 ; 
 ; WRITE WITH NEWLINE
writen(text) 
 w !,text
 q "0,writen^%Uxxxx"
 ; 
 ; 
 ; WRITE WITH NEWLINE/PROMPT
writep(text) 
 n error
 w !,$$lprompt(text)
 q "0,writep^%Uxxxx"
 ; 
 ; 
 ; WRITE WITH FORMAT
writef(format,text) 
 n error,a
 s format=$g(format)
 f  q:format=""  s a=$p(format,","),format=$p(format,",",2,$l(format,",")) i a?."#"."!"!(a?1"?"1.n) x "w "_a
 w $g(text)
 q "0,writef^%Uxxxx"
 ; 
 ; 
 ; Create+write Error message
error(error) 
 i +error=-1 q $$writep("User abort")
 s error=$$writep("Error - "_$$lprompt(error))
 q error
 ; 
 ; HELP
 ; *** Needs to reference some global here
help(help,prompt) 
 n a,b,c,h s h=$g(help)
 q:h="" "0,help^%Uxxxx"
 ; 
 ; If contains ^ then assume executable code
 i h["^" x help q "0,help^%Uxxxx"
 ; 
 ; ensure contains .
 i h'["." s h="."_h
 ; 
 ; Now look up in %Uhelp - reference is meant to be routine.message
 ; if not found then shorten routine name one character at a time
%help1 i $d(@%Uwork("help")@(h,0)) g %help3
 s a=$p(h,".",1) i a="*" q $$writep("Help does not exist for - "_help)
 i a'="" s $p(h,".",1)=$e(a,1,$l(a)-1) g %help1
 ;
 ; Nothing found so try with prompt
 ; Note this doesn't work with read() and non-default language, 
 ; since prompt has already been translated to the alternative language
 s h="*."_$g(prompt) g %help1
 ;
 ; Having found then try for the defined language
 i '$d(%Uwork("lang")) s error=$$init
%help3 s a="",b=0,c=%Uwork("lang") i '$d(^(c)) s c=0
 f  s a=$o(@%Uwork("help")@(h,c,a)) q:a=""  s b=b+1 w !,^(a)
 q b_",help^%Uxxxx"
 ; 
 ; LANGUAGE CONVERSION
lprompt(prompt) i $g(prompt)="" q ""
 ; Remove trailing spaces before look-up and re-apply after
 ; Also everything after first -
 ; Everything before ~ is left unchanged and ~ replaced by -
 i '$d(%Uwork("lang")) s error=$$init        
 n s,t,u
 s u="" i prompt["~" s u=$p(prompt,"~")_" - ",prompt=$p(prompt,"~",2,$l(prompt,"~"))
 s t=$f(prompt,"-")-2
 i 't s t=$l(prompt)
 f t=t:-1 q:$e(prompt,t)'=" "
 s s=$e(prompt,t,$l(prompt)),prompt=$e(prompt,1,t-1)
 i prompt'="" s t=$g(@%Uwork("prompt")@(%Uwork("lang"),prompt)) i t'="" s prompt=t
 q u_prompt_s
 ; 
 ; ********** UPPER/LOWER CONVERSION NEED TO HANDLE DIFFERENT LANGUAGES/CHARACTERS
upper(text) 
 s text=$tr(text,"abcdefghijklmnopqrstuvwxyz","ABCDEFGHIJKLMNOPQRSTUVWXYZ")
 q text
 ; 
lower(text) 
 s text=$tr(text,"ABCDEFGHIJKLMNOPQRSTUVWXYZ","abcdefghijklmnopqrstuvwxyz")
 q text
